# GOV.UK Mini Environment Admin
# Copyright © 2018  Christopher Baines <mail@cbaines.net>
#
# This file is part of the GOV.UK Mini Environment Admin.
#
# The GOV.UK Mini Environment Admin is free software: you can
# redistribute it and/or modify it under the terms of the GNU Affero
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later
# version.
#
# The GOV.UK Mini Environment Admin is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with the GOV.UK Mini Environment Admin.  If not, see
# <http://www.gnu.org/licenses/>.

class QueJobsController < ApplicationController
  def index
    @jobs = QueJob.order(id: :desc)
  end

  def cancel
    Que.execute :expire_job, [job_id]

    flash[:success] = 'Job canceled'

    redirect_to mini_environments_path
  end

  def retry_now
    ActiveRecord::Base.connection.execute(
      "UPDATE que_jobs
       SET run_at  = now()
       WHERE id    = #{job_id}::bigint"
    )

    flash[:success] = 'Retrying the job now'

    redirect_to mini_environments_path
  end

  def job_id
    params[:id].to_i
  end
end
