# GOV.UK Mini Environment Admin
# Copyright © 2018  Christopher Baines <mail@cbaines.net>
#
# This file is part of the GOV.UK Mini Environment Admin.
#
# The GOV.UK Mini Environment Admin is free software: you can
# redistribute it and/or modify it under the terms of the GNU Affero
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later
# version.
#
# The GOV.UK Mini Environment Admin is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with the GOV.UK Mini Environment Admin.  If not, see
# <http://www.gnu.org/licenses/>.

# == Schema Information
#
# Table name: terraform_libvirt_backends
#
#  id         :integer          not null, primary key
#  label      :string
#  uri        :string
#  created_at :datetime         not null
#  updated_at :datetime         not null
#  domain     :string
#

require 'ruby_terraform'

class Backends::TerraformLibvirt < ApplicationRecord
  include MiniEnvironmentMethods
  include BackendMethods

  has_many :mini_environments, as: :backend

  self.table_name = 'terraform_libvirt_backends'

  def self.label
    'libvirt'
  end

  def type_and_id
    "#{self.class.name}=#{id}"
  end

  def available_data_snapshots
    GovukGuix::DataSnapshot.where(backend: nil)
  end

  def terraform_state_id
    "backend/terraform_libvirt/#{id}"
  end
end
