variable "uri" {
  type = "string"
}

terraform {
  backend "http" {}
}

provider "libvirt" {
  uri = "${var.uri}"
}

resource "libvirt_network" "main" {
  name = "vm_network"
  addresses = ["10.0.1.0/24"]

  dhcp {
    enabled = true
  }

  dns {
    local_only = true
  }
}

output "network_name" {
  value = "${libvirt_network.main.name}"
}

output "backend_up" {
  value = "${length(libvirt_network.main.name) != 0}"
}
